//      C_CUST.H:  Defines for C Customisation
/*
*     Copyright (C) 2003, 2004, 2005, 2006, 2008 Chris Gordon-Smith
*     Email: See http://www.simsoup.info/
*
*     This program is free software; you can redistribute it and/or modify it
*     under the terms of the GNU General Public License Version 2, as published 
*     by the Free Software Foundation.
*
*     This program is distributed in the hope that it will be useful, but
*     WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
*     or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
*     for more details.
*
*     You should have received a copy of the GNU General Public License along
*     with this program; if not, write to the Free Software Foundation, Inc.,
*     59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*
*     See the file Licence.txt for a copy of the GNU General Public License.
*/
//  Defines for Logical Operators

//  Block Constructs

#define   BEGIN  {
#define   END    }

//  If statement constructs

#define   THEN      {
#define   ELSEIF    }else if
#define   ELSE      }else{
#define   ENDIF     }

//  Switch Statement Constructs

#define   FIRSTCASE  {case
#define   NEXTCASE   break;case
#define   DEFAULT    break;default
#define   ENDSWITCH  }

//  Macro to Create an object and update System Monitor
//  if system monitoring enabled

#ifdef  ENABLE_SYSTEM_MONITOR
#define CREATE_OBJECT(Class_Name,New_Statement) \
New_Statement; \
System_Monitor::Get_Ptr()->Object_Creation(string(#Class_Name));
#else
#define CREATE_OBJECT(Class_Name,New_Statement) \
New_Statement;
#endif

//  Macro to Delete an object and update System Monitor
//  if system monitoring enabled

#ifdef  ENABLE_SYSTEM_MONITOR
#define DELETE_OBJECT(Class_Name,Object__Ptr) \
if (Object__Ptr != 0) System_Monitor::Get_Ptr()->Object_Deletion(string(#Class_Name)); \
delete Object__Ptr;
#else
#define DELETE_OBJECT(Class_Name,Object__Ptr) \
delete Object__Ptr;
#endif

