/****************************************************************************
*
*     Header Filename:  Simulation_Scheduler.h
*     Module Name:      Simulation_Scheduler
*     Description:      Manages simulation processing while there is no user input 
*                       to be processed by the user interface
*
*	  Author:           Chris Gordon-Smith
*
*     Copyright (C) 2007, 2008 Chris Gordon-Smith
*     Email: See http://www.simsoup.info/
*
*     This program is free software; you can redistribute it and/or modify it
*     under the terms of the GNU General Public License as published by the
*     Free Software Foundation; either version 2 of the License, or (at your
*     option) any later version.
*
*     This program is distributed in the hope that it will be useful, but
*     WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
*     or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
*     for more details.
*
*     You should have received a copy of the GNU General Public License along
*     with this program; if not, write to the Free Software Foundation, Inc.,
*     59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*
*     See the file Licence.txt for a copy of the GNU General Public License.
*
*      Amendment History:- 
*
*              Version	  Date                        Update Description
*              =======    ===========                 ==================
*
*
*
*
****************************************************************************/

#ifndef Simulation_Scheduler_H
#define Simulation_Scheduler_H


class Simulation_Scheduler

{
    public:
        bool  SimProc_IsEnabled();
        void  Disable_Simulation_Processing();
        void  Enable_Simulation_Processing();
        static Simulation_Scheduler*  Get_Ptr() {return Instance_Ptr;};
        Simulation_Scheduler();
        static void Make();
        bool Handle_Processing_Time_Available_Notification();
    private:
        static Simulation_Scheduler* Instance_Ptr;
        bool  Simulation_Processing_Enabled;
};
#endif  //Simulation_Scheduler_H
