/****************************************************************************
*
*	  Module Filename:  Form_View_Reactor.cpp
*	  Module Name:      Form_View_Reactor
*	  Description:      View The Reactor
*	  Author:           Chris Gordon-Smith
*
*     Copyright (C) 2003, 2004, 2005, 2006, 2008 Chris Gordon-Smith
*     Email: See http://www.simsoup.info/
*
*     This program is free software; you can redistribute it and/or modify it
*     under the terms of the GNU General Public License Version 2, as published 
*     by the Free Software Foundation.
*
*     This program is distributed in the hope that it will be useful, but
*     WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
*     or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
*     for more details.
*
*     You should have received a copy of the GNU General Public License along
*     with this program; if not, write to the Free Software Foundation, Inc.,
*     59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*
*     See the file Licence.txt for a copy of the GNU General Public License.
*
*	  Amendment History:-
*
*		Version	   Date	   			Update Description
*		=======    ===========		==================
*
*
*
*
****************************************************************************/

//	Globally used defines

#include    "globldef.h"
#include    "Library_Headers.h"

//----------------  User_Interface_Presentation API --------------------------------------------------------------
#include  "GUI_Presentation_API.h"
//----------------------------------------------------------------------------------------------------------------

//--------------  Network Painter Subsystem  --------------------------------------------------------------------
#include "Network_Painter_Prot.h"
//---------------------------------------------------------------------------------------------------------------

//--------------  User Interface Manager  -----------------------------------------------------------------------
#include    "Form_View_Reactor.h"
#include    "Form_Main.h"
//---------------------------------------------------------------------------------------------------------------

//--------------  Kernel_Manager Subsystem  ----------------------------------------------------------------------
#include  "Krnl_Vis.h"
//----------------------------------------------------------------------------------------------------------------

TForm__View_Reactor* TForm__View_Reactor::Form_Ptr = 0;
//----------------------------------------------------------------------------------------------------------

void  TForm__View_Reactor::Close_View()

//      Class specific actions required when the Chemistry View is closed

{
    Form_Ptr = 0;

//  Update menu options
    
//    MainForm::Get_Ptr()->Window_Reactor->Enabled = false;
//    MainForm::Get_Ptr()->Reactor_View->Enabled = true;
}
    
//----------------------------------------------------------------------------------------------------------

int TForm__View_Reactor::Compare_Nodes(void*  Node1_Ptr, void* Node2_Ptr) const
{
//  ***** TO BE COMPLETED

    Assert (Node1_Ptr != 0,"TForm__View_Reactor::Compare_Connections - Node1_Ptr is invalid");
    Assert (Node2_Ptr != 0,"TForm__View_Reactor::Compare_Connections - Node2_Ptr is invalid");
    Assert (1 == 0,"TForm__View_Reactor::Compare_Nodes - Not yet implemented");
    return(0);
}
//----------------------------------------------------------------------------------------------------------

int TForm__View_Reactor::Compare_Connections(void*  Connect1_Ptr, void* Connect2_Ptr) const
{
//  ***** TO BE COMPLETED
    Assert (Connect1_Ptr != 0,"TForm__View_Reactor::Compare_Connections - Connect1_Ptr is invalid");
    Assert (Connect2_Ptr != 0,"TForm__View_Reactor::Compare_Connections - Connect1_Ptr is invalid");
    Assert (1 == 0,"TForm__View_Reactor::Compare_Connections - Not yet implemented");

    return(0);
}
//----------------------------------------------------------------------------------------------------------

void  TForm__View_Reactor::Draw_All_Connections() const

//  Display all Realisable_Interaction_Types in the Reactor


{

//  Loop over all Realisable_Interaction_Types in the Reactor

    for(int Continue_Flag = Krnl_Vis::Reactor_::Iter_To_First_R_Int_Type();
        Continue_Flag == true;
        Continue_Flag = Krnl_Vis::Reactor_::Iter_To_Next_R_Int_Type())
    BEGIN
//      ***  Test purposes only
//      **********************

//        Realisable_Interaction_Type*  R_Int_Type_Ptr = Reactor__Ptr->Get_Current_R_Int_Type_Ptr();
//        Interaction_Type*  Int_Type_Ptr = R_Int_Type_Ptr->Get_Interaction_Type_Ptr();

//        if ((Int_Type_Ptr->Get_Reactant1_MolType_Ptr()->Get_Identifier() > 119)
//                &&
//            (Int_Type_Ptr->Get_Reactant2_MolType_Ptr()->Get_Identifier() > 119)
//           )
//        THEN
            Draw_Connection(Krnl_Vis::Reactor_::Get_Current_R_Int_Type_Ptr(),
            EOpt_Connection_Not_Selected);
//        ENDIF
    END
}


//----------------------------------------------------------------------------------------------------------
void  TForm__View_Reactor::Draw_All_Nodes() const

//  Display all Realised_Molecule_Types in the Reactor

{
    for (int Continue_Flag = Krnl_Vis::Reactor_::Iter_To_First_R_Mol_Type();
         Continue_Flag == true;
         Continue_Flag = Krnl_Vis::Reactor_::Iter_To_Next_R_Mol_Type())
    BEGIN
        Draw_Node(Krnl_Vis::Reactor_::Get_Current_R_Mol_Type_Ptr());
    END
}
//----------------------------------------------------------------------------------------------------------

void  TForm__View_Reactor::Draw_Connection(void* Void__R_Int_Type_Ptr,
                     int Conn_Selection_State) const

//  Draw the specified Realisable Interaction Type Reactor View

{

    Realisable_Interaction_Type* R_IntType__Ptr = static_cast<Realisable_Interaction_Type*> (Void__R_Int_Type_Ptr);
    Interaction_Type* IntType__Ptr = Krnl_Vis::Realisable_IntType::Get_Interaction_Type_Ptr(R_IntType__Ptr);

    int Interaction_Type_Identifier;
    Interaction_Type_Enum  Interaction_Type_Enumr;
    int Reactant1_Identifier;
    int Reactant2_Identifier;
    int Product1_Identifier;
    int Product2_Identifier;
    int Catalyst_Identifier;

    Krnl_Vis::IntType::Get_Int_Type_Characteristics(IntType__Ptr,
                                                    Interaction_Type_Identifier,
                                                    Interaction_Type_Enumr,
                                                    Reactant1_Identifier,
                                                    Reactant2_Identifier,
                                                    Product1_Identifier,
                                                    Product2_Identifier,
                                                    Catalyst_Identifier);

    if (Interaction_Type_Enumr == Interaction_Type_Enumr__Fission)
    THEN
        Network_Painter_Prot__Ptr->Draw_Fission(Reactant1_Identifier,
                                                Product1_Identifier,
                                                Product2_Identifier,
                                                1,      // Draw all lines withthe same width
                                                Conn_Selection_State,
                                                true);
    ELSEIF (Interaction_Type_Enumr == Interaction_Type_Enumr__Constr)
    THEN
        Network_Painter_Prot__Ptr->Draw_Construction(Reactant1_Identifier,
                                                    Reactant2_Identifier,
                                                    Product1_Identifier,
                                                    1,      // Draw all lines withthe same width
                                                    Conn_Selection_State,
                                                    true); // Draw for first time, so create a Network Display Item
                                                            // in case need to redraw;

    ELSEIF (Interaction_Type_Enumr == Interaction_Type_Enumr__Transfm)
    THEN
        Network_Painter_Prot__Ptr->Draw_Transformation(Reactant1_Identifier,
                                                       Product1_Identifier,
                                                       1,      // Draw all lines withthe same width
                                                       Conn_Selection_State,
                                                       true);

    ELSE
        Assert (true == false, "TForm__View_Reactor::Draw_Connection - Invalid Interaction Type");
    ENDIF
}

//----------------------------------------------------------------------------------------------------------
void    TForm__View_Reactor::Draw_Node(void* Void__Realised_Molecule_Type_Ptr) const


//  Invoke the Molecule_Type's Draw method to draw the Realised_Molecule Type with
//  a size indicating the number of Molecules of the type in the Reactor

{

    Realised_Molecule_Type*  Realised_Molecule_Type__Ptr
        = static_cast<Realised_Molecule_Type*> (Void__Realised_Molecule_Type_Ptr);
    int MolType_Identifier = 
        Krnl_Vis::MolType::Get_Identifier(Krnl_Vis::R_MolType::Get_Molecule_Type_Ptr(Realised_Molecule_Type__Ptr));
    int Display_Size =  Krnl_Vis::R_MolType::Get_Num_Of_Mols_In_Reactor(Realised_Molecule_Type__Ptr);


//  Invoke the Draw method.  

    if (Display_Size not_eq 0) Display_Size = 5;  // Standard display size

    Network_Painter_Prot__Ptr->Draw_Molecule_Type(MolType_Identifier,
                                         Display_Size,
                                         EOpt_Node_Not_Selected,
                                         true); // Draw for first time, so create a Network Display Item
                                                // in case need to redraw;
//    Realised_Molecule_Type__Ptr->Get_Molecule_Type_Ptr()->Draw(Network_Painter_Prot__Ptr,Display_Size);
//    Realised_Molecule_Type__Ptr->Get_Molecule_Type_Ptr()->Draw(Network_Painter_Prot__Ptr,Display_Size);
}
//----------------------------------------------------------------------------------------------------------

void    TForm__View_Reactor::Draw_Selected_Nodes()  

//  No need to draw selected nodes in the Reactor view

{
}
//----------------------------------------------------------------------------------------------------------
void   TForm__View_Reactor::Draw_Text_Output() const

//  Writes appropriate text for the Reactor to the Network Display using the Network Painter

{/*
    string Output_Text = "Time = ";
    Output_Text.append(To_String(Reactor__Ptr->Get_Reactor_Time()));

//  Set position 
    
    int XPos = static_cast <int> (0.75 * (TPaintBox__Network_Display_Ptr->Get_Width()));
    int YPos = static_cast <int> (0.95 * TPaintBox__Network_Display_Ptr->Get_Height());

    Network_Painter_Prot__Ptr->Draw_Text_Output(XPos, YPos, Output_Text.c_str(), true);
                                                // Remember the text for later redraw
*/
}
//----------------------------------------------------------------------------------------------------------

void    TForm__View_Reactor::Get_Conns_Matching_Node_And_Type
                                        (list<void*>& List_Of_Connections,
                                         int  Node_Index,
                                         Enum_Node_Selection_State  Selection_State)

{
     Assert(1==0,"TForm__View_Reactor::Get_Conns_Matching_Node_And_Type - Not yet implemented");
}
//----------------------------------------------------------------------------------------------------------

int TForm__View_Reactor::Get_Number_Of_Possible_Nodes()

//  Get the number of Molecule Types in the Reactor that are possible.
//  This is just the number of Molecule_Types in the Chemistry

{
//    Chemistry*  Chem_Ptr = Chemistry::Get_Chemistry__Ptr();
//    Assert (Chem_Ptr != 0,
//            "TForm__View_Reactor::Get_Number_Of_Possible_Nodes -  Invalid value of Chemistry__Ptr");
    return Krnl_Vis::Chemistry_::Get_Number_Of_Molecule_Types();
}
//----------------------------------------------------------------------------------------------------------

bool   TForm__View_Reactor::Is_On_Active_Page()

//  Return true if the Main Tab (which has the Reactor View) is on the currently active page

{   
   
    string Name = GUI_Presentation_API::Get_Active_Page_Label();
    if (Name == string("Chemistry and Reactor Views"))
    THEN
        return true;
    ELSE
        return false;
    ENDIF
}
//----------------------------------------------------------------------------------------------------------

void    TForm__View_Reactor::List_Connections_For_Node(void* Node_Ptr) const

//  List the Realisable_Interaction_Types associated with the specified
//  Node (Realised_Molecule_Type). (Don't show those that have been logically deleted)

//  Show all Realisable_Interaction_Types that have the Realised_Molecule_Type
//  as an Input or Product

//  Link each ListItem to the Realisable_Interaction_Type that it identifies

{
    GUI_Presentation_API::Clear(Widget_Ids::R_IntType_ListStore);

    Realised_Molecule_Type* Realised_Molecule_Type__Ptr
        = static_cast<Realised_Molecule_Type*>  (Node_Ptr);

    Molecule_Type* MolType_Ptr = Krnl_Vis::R_MolType::Get_Molecule_Type_Ptr(Realised_Molecule_Type__Ptr);
    int Selected_Mol_Type_Identifier = Krnl_Vis::MolType::Get_Identifier(MolType_Ptr);

    //  Loop over all Realisable_Interaction_Types. Filter on those not associated with
    //  the specified Realised_Molecule_Type, and display those remaining.

    for (bool Continue_Flag = Krnl_Vis::Reactor_::Iter_To_First_R_Int_Type();
         Continue_Flag == true;
         Continue_Flag = Krnl_Vis::Reactor_::Iter_To_Next_R_Int_Type())
    BEGIN

//        if (Reactor__Ptr->Get_Iterators_Ptr()->Get_Current_R_Int_Type_Ptr()->Get_Unrealisable() == false)
        Realisable_Interaction_Type*  Ptr = Krnl_Vis::Reactor_::Get_Current_R_Int_Type_Ptr();
        if (Krnl_Vis::Realisable_IntType::Get_Unrealisable(Ptr) == false)
        THEN

//          Check for an Input to the R Int Type that matches the selected Realised_Molecule_Type

            CREATE_OBJECT(VCSList, VCSList* TList__Input_Mol_Types_Ptr = new VCSList);
            Realisable_Interaction_Type*  R_IntType_Ptr = Krnl_Vis::Reactor_::Get_Current_R_Int_Type_Ptr();
            Interaction_Type*  IntType_Ptr 
                = Krnl_Vis::Realisable_IntType::Get_Interaction_Type_Ptr(R_IntType_Ptr);

            Krnl_Vis::IntType::Get_Int_Type_Inputs_No_Dups(IntType_Ptr, TList__Input_Mol_Types_Ptr);

            bool R_Int_Type_To_Be_Listed_Flag = false;

            Molecule_Type*  Mol_Type_Ptr;

            for (int Input_Counter = 0;
                Input_Counter < TList__Input_Mol_Types_Ptr->Count();
                Input_Counter++)
            BEGIN
                Mol_Type_Ptr = static_cast<Molecule_Type*> (TList__Input_Mol_Types_Ptr->Get_Item(Input_Counter));

                if(Krnl_Vis::MolType::Get_Identifier(Mol_Type_Ptr) == Selected_Mol_Type_Identifier)

                THEN

                    R_Int_Type_To_Be_Listed_Flag = true;
                END
            END

            DELETE_OBJECT(VCSList, TList__Input_Mol_Types_Ptr);

//          Check for a Product from the R Int Type that matches the selected Realised_Molecule_Type

            CREATE_OBJECT(VCSList, VCSList* TList__Product_Mol_Types_Ptr = new VCSList);

            Realisable_Interaction_Type*  Realisable_IntType_Ptr = Krnl_Vis::Reactor_::Get_Current_R_Int_Type_Ptr();
            IntType_Ptr 
                = Krnl_Vis::Realisable_IntType::Get_Interaction_Type_Ptr(Realisable_IntType_Ptr);
            Krnl_Vis::IntType::Get_Int_Type_Products_With_Dups(IntType_Ptr, TList__Product_Mol_Types_Ptr);

            for (int Product_Counter = 0;
                Product_Counter < TList__Product_Mol_Types_Ptr->Count();
                Product_Counter++)
            BEGIN
                Mol_Type_Ptr = static_cast<Molecule_Type*> (TList__Product_Mol_Types_Ptr->Get_Item(Product_Counter));
                if(Krnl_Vis::MolType::Get_Identifier(Mol_Type_Ptr) == Selected_Mol_Type_Identifier)

                THEN
                    R_Int_Type_To_Be_Listed_Flag = true;
                END
            END

            DELETE_OBJECT(VCSList, TList__Product_Mol_Types_Ptr);

//          Setup the Row and set its fields to
//          display the Connection characteristics. Also link the row to the R IntType

            if (R_Int_Type_To_Be_Listed_Flag)
            THEN
                Realisable_Interaction_Type* Realisable_IntType_Ptr = Krnl_Vis::Reactor_::
                                                                            Get_Current_R_Int_Type_Ptr();
                Interaction_Type* Int_Type_Ptr 
                    = Krnl_Vis::Realisable_IntType::Get_Interaction_Type_Ptr(Realisable_IntType_Ptr);

//              Setup the ListStore Row

                list<string>  List_Of_Strings;
                List_Of_Strings.push_back(To_String(Krnl_Vis::IntType::Get_Identifier(Int_Type_Ptr)));
//                List_Of_Strings.push_back(
//                    Interaction_Type::Support::Convert_Int_Type_Categ_To_Text(Int_Type_Ptr->Get_Category()).c_str());
                List_Of_Strings.push_back(Krnl_Vis::IntType::Convert_Int_Type_Categ_To_Text
                                                (Krnl_Vis::IntType::Get_Category(Int_Type_Ptr)));

                Realisable_Interaction_Type* Realisable_IntType_Ptr2 
                    = Krnl_Vis::Reactor_::Get_Current_R_Int_Type_Ptr();

                Krnl_Vis::Realisable_IntType::Update_Interaction_Rates(Realisable_IntType_Ptr, 
                                                                       Krnl_Vis::Reactor_::Get_Volume());
                List_Of_Strings.push_back(
                    To_String(Krnl_Vis::Realisable_IntType::Get_Interaction_Rate(Realisable_IntType_Ptr2)));

//              Include the identifiers of the participating Molecule_Types

                string R1_String(To_String(Krnl_Vis::IntType::Get_Reactant1_MolType_Id(Int_Type_Ptr)));
                List_Of_Strings.push_back(R1_String);

//                string R1_String(Interaction_Type::Support::Get_Reactant1_Identifier_Text(Int_Type_Ptr).c_str());
//                List_Of_Strings.push_back(R1_String);

//                string R2_String(Interaction_Type::Support::Get_Reactant2_Identifier_Text(Int_Type_Ptr).c_str());
//                List_Of_Strings.push_back(R2_String);

                string R2_String(Krnl_Vis::IntType::Get_Reactant2_MolType_Text(Int_Type_Ptr));
                List_Of_Strings.push_back(R2_String);

                string P1_String(To_String(Krnl_Vis::IntType::Get_Product1_MolType_Id(Int_Type_Ptr)));
                List_Of_Strings.push_back(P1_String);

//                string P1_String(Interaction_Type::Support::Get_Product1_Identifier_Text(Int_Type_Ptr).c_str());
//                List_Of_Strings.push_back(P1_String);

//                string P2_String(Interaction_Type::Support::Get_Product2_Identifier_Text(Int_Type_Ptr).c_str());
//                List_Of_Strings.push_back(P2_String);

                string P2_String(Krnl_Vis::IntType::Get_Product2_MolType_Text(Int_Type_Ptr));
                List_Of_Strings.push_back(P2_String);

                GUI_Presentation_API::Add_Row(Widget_Ids::R_IntType_ListStore, 
                                              List_Of_Strings,
                                              static_cast <void*> (Krnl_Vis::Reactor_::Get_Current_R_Int_Type_Ptr()));
            ENDIF
        ENDIF        
    END
}
//----------------------------------------------------------------------------------------------------------

 void    TForm__View_Reactor::List_Nodes() const

//  List the Realised_Molecule_Types associated with the Reactor and
//  show details of the Realised_Molecule_Type
//  In addition, link the display item to the Realised_Molecule_Type data

{
    Molecule_Type*  Molecule_Type__Ptr;
    Realised_Molecule_Type*  Realised_Molecule_Type__Ptr;

    GUI_Presentation_API::Clear(Widget_Ids::R_MolType_ListStore);
    GUI_Presentation_API::Clear(Widget_Ids::R_IntType_ListStore);  // Because it will not be correct 
                                                                   // after the redisplay
    
    for (int Continue_Flag = Krnl_Vis::Reactor_::Iter_To_First_R_Mol_Type();
         Continue_Flag == true;
         Continue_Flag = Krnl_Vis::Reactor_::Iter_To_Next_R_Mol_Type())
    BEGIN
        Realised_Molecule_Type__Ptr = Krnl_Vis::Reactor_::Get_Current_R_Mol_Type_Ptr();
        Molecule_Type__Ptr = Krnl_Vis::R_MolType::Get_Molecule_Type_Ptr(Realised_Molecule_Type__Ptr);

        list<string>  List_Of_Strings;
        List_Of_Strings.push_back(To_String(Krnl_Vis::MolType::Get_Identifier(Molecule_Type__Ptr)));
        List_Of_Strings.push_back(To_String(Krnl_Vis::R_MolType::Get_Num_Of_Mols_In_Reactor(Realised_Molecule_Type__Ptr)));

        GUI_Presentation_API::Add_Row(Widget_Ids::R_MolType_ListStore, 
                                      List_Of_Strings,
                                      static_cast <void*> (Realised_Molecule_Type__Ptr)); 
    END
}
//----------------------------------------------------------------------------------------------------------------

void  TForm__View_Reactor::Make()

//  Create the TForm__View_Reactor singleton object and initialise display

{
    Assert(Form_Ptr == 0,"TForm__View_Reactor::Make -  Invalid call; TForm__View_Reactor has already been created");
    CREATE_OBJECT(TForm__View_Reactor, Form_Ptr = new TForm__View_Reactor);   
}
//----------------------------------------------------------------------------------------------------------------

void  TForm__View_Reactor::Notify_R_MolType_ListView_Selection(void*  Data_Ptr)

//  Handler for notification of selection of an item in the Realised MolType ListView

{
    if (Krnl_Vis::Simulation_Scheduler_::SimProc_IsEnabled()) return;  
    Realised_Molecule_Type*  R_MolType_Ptr;
    R_MolType_Ptr = static_cast <Realised_Molecule_Type*> (Data_Ptr);
    List_Connections_For_Node(R_MolType_Ptr);
}
//----------------------------------------------------------------------------------------------------------

void TForm__View_Reactor::Remove_And_Replace_Connections(int Old_Node_Index, int Current_Node_Index)

//  Does nothing for Reactor View

{
    Assert (Old_Node_Index != 0,"TForm__View_Reactor::Remove_And_Replace_Connections - Invalid Old_Node_Index");
    Assert (Current_Node_Index != 0,"TForm__View_Reactor::Remove_And_Replace_Connections - Invalid Current_Node_Index");
    Assert (1 == 0,"TForm__View_Reactor::Remove_And_Replace_Connections - INot yet implemented");
}

//----------------------------------------------------------------------------------------------------------


void    TForm__View_Reactor::Show_Reactor(int Num_Nodes)

//  Show a Reactor View

{
    if (!Form_Ptr)

    THEN
        CREATE_OBJECT(TForm__View_Reactor,Form_Ptr = new TForm__View_Reactor());
    ENDIF
    

    Form_Ptr->Set_Number_Of_Nodes(Num_Nodes);
//    Form_Ptr->SetFocus();
}    
//----------------------------------------------------------------------------------------------------------

TForm__View_Reactor::TForm__View_Reactor() : TForm__View_Network()

{
//    Reactor__Ptr = Reactor::Get_Reactor__Ptr();
    Form_Ptr = this;   // Form_Ptr is static

//  Initialise the form

    Initialise_Form(Get_Number_Of_Possible_Nodes(),
                    true,  // Display all Realised Interaction Types initially
                    Widget_Ids::Reactor_Draw_Area);
}
//----------------------------------------------------------------------------------------------------------
