/****************************************************************************
*
*	  Header Filename:  Form_View_Reactor.h
*	  Module Name:      Form_View_Reactor
*	  Description:      View the Reactor
*	  Author:           Chris Gordon-Smith
*
*     Copyright (C) 2003, 2004, 2005, 2006, 2008 Chris Gordon-Smith
*     Email: See http://www.simsoup.info/
*
*     This program is free software; you can redistribute it and/or modify it
*     under the terms of the GNU General Public License Version 2, as published 
*     by the Free Software Foundation.
*
*     This program is distributed in the hope that it will be useful, but
*     WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
*     or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
*     for more details.
*
*     You should have received a copy of the GNU General Public License along
*     with this program; if not, write to the Free Software Foundation, Inc.,
*     59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*
*     See the file Licence.txt for a copy of the GNU General Public License.
*
*	  Amendment History:-
*
*		Version	   Date	   			Update Description
*		=======    ===========		==================
*
*
*
*
****************************************************************************/

#ifndef Form_View_Reactor_H
#define Form_View_Reactor_H


//	Declaration of inherited class(es)

#include    "Form_View_Network.h"

// 	Non inherited Class(es) and data structures used in class declaration

class   Reactor;
class   Realised_Molecule_Type;
class   Molecule_Type;

//	Class declaration

class TForm__View_Reactor : public TForm__View_Network
{

//      Friend Classes amd Functions

    private:
//===== Relationships with other classes =====================================================================================
        Reactor*    Reactor__Ptr;
//==========================================================================================================================
    public:
        TForm__View_Reactor();
        static void  Make();

        bool    Is_On_Active_Page();
        static  void  Show_Reactor(int Num_Nodes);
        static  TForm__View_Reactor*  Get_Ptr() {return Form_Ptr;}
        void    List_Nodes() const;
        void    Notify_R_MolType_ListView_Selection(void*  Data_Ptr);


    private:
//      Private Class Data

        static TForm__View_Reactor*  Form_Ptr;  // Pointer to an Open View
                                                // Set zero if no open View

    private:

        void    Close_View();

        void    Draw_All_Connections() const;
        void    Draw_All_Nodes() const;
        void    Draw_Connection(void* Void__Realisable_Interaction_Ptr,
                     int Conn_Selection_State) const;
        void    Draw_Node(void* Void__Realised_Molecule_Type_Ptr) const;
        void    Draw_Selected_Nodes() ;
        void    Draw_Text_Output() const;
        
        Molecule_Type*    Get_Selected_Mol_Type() const;
        void    List_Connections_For_Node(void* Node_Ptr) const;

        int     Compare_Nodes(void*  Node1_Ptr, void* Node2_Ptr) const;
        int     Compare_Connections(void*  Connect1_Ptr, void* Connect2_Ptr) const;

        void    Get_Conns_Matching_Node_And_Type
                                        (list<void*>& List_Of_Connections,
                                         int  Node_Index,
                                         Enum_Node_Selection_State  Selection_State);
//        TListView* Get_Laz_ListView_Nodes_Ptr();

        int     Get_Number_Of_Possible_Nodes();
        void    Remove_And_Replace_Connections(int Old_Node_Index, int Current_Node_Index);


//      User Interface Functions


//        void SpeedButton__Sim_Go_Click();

};

#endif  // Form_View_Reactor_H
